name: CI/CD Pipeline

on: push

env:
  CARGO_TARGET: x86_64-unknown-linux-musl
  SSH_HOST: ${{ secrets.SSH_HOST }}
  SSH_USER: ${{ secrets.SSH_USER }}
  SSH_PRIVATE_KEY: ${{ secrets.SSH_PRIVATE_KEY }}

jobs:
  test:
    runs-on: ubuntu-latest
    container: git.hofer.link/ruderverein-donau-linz/rowing-ci:20240215
    steps:
    - uses: actions/checkout@v3
    - name: Run Test DB Script
      run: ./test_db.sh

    - name: Set up cargo cache
      uses: actions/cache@v3
      with:
        path: |
          ~/.cargo/bin/
          ~/.cargo/registry/index/
          ~/.cargo/registry/cache/
          ~/.cargo/git/db/
          target/
        key: ${{ runner.os }}-cargo-debug-rowt-${{ hashFiles('**/Cargo.lock') }}
        restore-keys: ${{ runner.os }}-cargo-debug-rowt-

    - name: Build
      run: |
        cargo build 
        cd frontend && npm install && npm run build
    - name: Frontend tests
      run: cd frontend && npx playwright install && npx playwright test --workers 1 --reporter line
    - name: Backend tests
      run: cargo test --verbose
    #- uses: actions/upload-artifact@v3
    #  if: always()
    #  with:
    #    name: playwright-report
    #    path: frontend/playwright-report/
    #    retention-days: 30

  deploy-staging:
    runs-on: ubuntu-latest
    container: git.hofer.link/ruderverein-donau-linz/rowing-ci:20240215
    needs: [test]
    if: github.ref == 'refs/heads/staging'
    steps:
      - name: Checkout
        uses: actions/checkout@v3
      
      - name: Run Test DB Script
        run: ./test_db.sh

      - name: Set up cargo cache
        uses: actions/cache@v3
        with:
          path: |
            ~/.cargo/bin/
            ~/.cargo/registry/index/
            ~/.cargo/registry/cache/
            ~/.cargo/git/db/
            target/
          key: ${{ runner.os }}-cargo-release-rowt-${{ hashFiles('**/Cargo.lock') }}
          restore-keys: ${{ runner.os }}-cargo-release-rowt-
      - name: Build
        run: |
          cargo build --release --target $CARGO_TARGET
          strip target/$CARGO_TARGET/release/rot
          cd frontend && npm install && npm run build

      - name: Deploy to Staging
        run: |
          mkdir -p ~/.ssh
          ssh-keyscan -H $SSH_HOST >> ~/.ssh/known_hosts
          echo "$SSH_PRIVATE_KEY" > ~/.ssh/id_rsa
          chmod 600 ~/.ssh/id_rsa

          scp target/$CARGO_TARGET/release/rot $SSH_USER@$SSH_HOST:/home/rowing-staging/rot-updating
    
          scp staging-diff.sql $SSH_USER@$SSH_HOST:/home/rowing-staging/
          scp -r static $SSH_USER@$SSH_HOST:/home/rowing-staging/
          scp -r templates $SSH_USER@$SSH_HOST:/home/rowing-staging/
          scp -r svelte $SSH_USER@$SSH_HOST:/home/rowing-staging/
          ssh $SSH_USER@$SSH_HOST 'sudo systemctl stop rotstaging'
          ssh $SSH_USER@$SSH_HOST 'rm /home/rowing-staging/db.sqlite && cp /home/rowing/db.sqlite /home/rowing-staging/db.sqlite && mkdir -p /home/rowing-staging/svelte/build && mkdir -p /home/rowing-staging/data-ergo/thirty && mkdir -p /home/rowing-staging/data-ergo/dozen && sqlite3 /home/rowing-staging/db.sqlite < /home/rowing-staging/staging-diff.sql'
          ssh $SSH_USER@$SSH_HOST 'mv  /home/rowing-staging/rot-updating /home/rowing-staging/rot'
          ssh $SSH_USER@$SSH_HOST 'sudo systemctl start rotstaging'
        env:
          SSH_PRIVATE_KEY: ${{ secrets.SSH_PRIVATE_KEY }}
          SSH_HOST: ${{ secrets.SSH_HOST }}
          SSH_USER: ${{ secrets.SSH_USER }}

  deploy-main:
    runs-on: ubuntu-latest
    container: git.hofer.link/ruderverein-donau-linz/rowing-ci:20240215
    needs: [test]
    if: github.ref == 'refs/heads/main'
    steps:
      - name: Checkout
        uses: actions/checkout@v3
      
      - name: Run Test DB Script
        run: ./test_db.sh
      
      - name: Set up cargo cache
        uses: actions/cache@v3
        with:
          path: |
            ~/.cargo/bin/
            ~/.cargo/registry/index/
            ~/.cargo/registry/cache/
            ~/.cargo/git/db/
            target/
          key: ${{ runner.os }}-cargo-release-rowt-${{ hashFiles('**/Cargo.lock') }}
          restore-keys: ${{ runner.os }}-cargo-release-rowt-

      - name: Build
        run: |
          cargo build --release --target $CARGO_TARGET
          strip target/$CARGO_TARGET/release/rot
          cd frontend && npm install && npm run build

      - name: Deploy to production 
        run: |
          mkdir -p ~/.ssh
          ssh-keyscan -H $SSH_HOST >> ~/.ssh/known_hosts
          echo "$SSH_PRIVATE_KEY" > ~/.ssh/id_rsa
          chmod 600 ~/.ssh/id_rsa

          scp target/$CARGO_TARGET/release/rot $SSH_USER@$SSH_HOST:/home/rowing/rot-updating
          scp -r static $SSH_USER@$SSH_HOST:/home/rowing/
          scp -r templates $SSH_USER@$SSH_HOST:/home/rowing/
          scp -r svelte $SSH_USER@$SSH_HOST:/home/rowing/
          ssh $SSH_USER@$SSH_HOST 'mkdir -p /home/rowing/svelte/build && mkdir -p /home/rowing/data-ergo/thirty && mkdir -p /home/rowing/data-ergo/dozen'
          ssh $SSH_USER@$SSH_HOST 'sudo systemctl stop rot'
          ssh $SSH_USER@$SSH_HOST 'mv  /home/rowing/rot-updating /home/rowing/rot'
          ssh $SSH_USER@$SSH_HOST 'sudo systemctl start rot'
        env:
          SSH_PRIVATE_KEY: ${{ secrets.SSH_PRIVATE_KEY }}
          SSH_HOST: ${{ secrets.SSH_HOST }}
          SSH_USER: ${{ secrets.SSH_USER }}
